/* *******************************************************************************************
	This file contains the function declarations I used for my genetic algorithm. These
	functions helped me to create my league arrays, crossover, mutate, and run my fitness
	function (find the difference of the leagues).
   ******************************************************************************************* */

#ifndef FUNCTIONS
#define FUNCTIONS
#include "Team.h"
#include "BaseballPlayer.h"
#include <math.h>
#include <vector>
#include <algorithm>
#include<iostream>
#include <string>
#include <sstream>
#include <fstream>
#include <limits>
#include <array>
#include <cstdlib>
#include <ctime>
#include <random>
#include <cmath>
#include <Windows.h>
#include "BaseballPlayer.h"
#include "Team.h"


using namespace std;

//fcns
void makePlayerArray(Player p[]);
void makeTeamsArray(string t[]);
double findDifferenceSHOW(Team t[], int n);
double findDifferenceNOSHOW(Team t[], int n);
void draftTeam(string nm, Player team[], double & score, Player p[], int teamSize);
void createLeague(int numt, string teams[], Player p[], Team league[]);
int setupNumTeams();
int setupNumLeagues();
void swapArrays(Team arr1[], Team arr2[], int s);
void tradePlayers(Team league[], int n, int m, int r);
void copyArrays(Team multi[], Team nextgen[], int numleag, int t);
void playerMutation(Team league[], int n, int m, int r);

//vars
const int NUMTEAMS = 30;
const int NUMLEAGUES = 30;
#endif