/* *******************************************************************************************
	This file contains my Player object private variables and functions. These functions 
	helped me out greatly because I was able to access and change private variables personal
	to each individual player. 
   ******************************************************************************************* */

#include<iostream>
#include <string>
#include <sstream>
#include <fstream>
#include <limits>
#include "BaseballPlayer.h"

using namespace std;


void Player::getPlayer(string line)
{
	istringstream stream(line);
	stream >> firstName >> lastName >> WAR >> pos;
	if (pos == "P")
		enumpos = PITCHER;
	else if (pos == "C")
		enumpos = CATCHER;
	else if (pos == "INF")
		enumpos = INFIELD;
	else if (pos == "OF")
		enumpos = OUTFIELD;
	drafted = false;
}

void Player::displayPlayer()
{
	cout << firstName << " " << lastName << "\n";
	//cout << "WAR : " << WAR << "\n";
	//cout << "Pos : " << pos << "\n";
	/*cout << "Drafted?  ";
	if (drafted)
		cout << "YES" << endl;
	else
		cout << "NO" << endl;
	cout << endl;*/
	//cout << enumpos << endl;
}

bool Player::isHeDrafted()
{
	if (drafted == true)
		return true;
	else
		return false;
}

void Player::draftPlayer()
{
	drafted = true;
}

string Player::getPosition()
{
	return pos;
}

double Player::getWAR()
{
	return WAR;
}

void Player::releasePlayer()
{
	if (drafted == true)
		drafted = false;
}

int Player::getEnumPos()
{
	return enumpos;
}

void Player::changeWAR(double newwar)
{
	WAR = newwar;

	return;
}
