/* ******************************************************************************************* 
	This file contains my BaseballPlayer object private variables and function headers.
	The enumerated value for each baseball player helps me know where each player is held 
	in the team arrays. 
   ******************************************************************************************* */

#ifndef BASEBALLPLAYER_H
#define BASEBALLPLAYER_H
#include<iostream>
#include <string>
#include <sstream>
#include <fstream>
#include <limits>

using namespace std;
const int playerSize = 563;   //as of 2/20/2023

enum posvalue
{
	PITCHER = 0, CATCHER = 1, INFIELD = 2, OUTFIELD = 3
};

class Player
{
	string firstName, lastName, pos;
	posvalue enumpos;
	double WAR;
	bool drafted;
public:
	void getPlayer(string line);
	void displayPlayer();
	bool isHeDrafted();
	void draftPlayer();
	string getPosition();
	double getWAR();
	void releasePlayer();
	int getEnumPos();
	void changeWAR(double n);
};

#endif